--Handles to keep teams
local cpu_frontline = 5
local cpu_main = 6
local cpu_bzooka = 7
local cpu_furies = 8

-- FURIES --
-- Wave
local furyTimeNext = 1200
local furyTimeAdd = 240
local furyWave = 0
-- Tanks
local furyTanks = {}
local furyTanksToBuild = {3, 6, 9, 12, 15, 16, 17, 18, 19, 22, 26, 28, 30, 33, 50}
-- Saucers
local furySaucers = {}
local furySaucersToBuild = {6, 9, 12, 15, 18, 21, 24, 27, 29, 32, 45}
-- Fury
local totalFuries = {}
-- Fury tanks
local furyTanks = {}
-- Fury saucers
local furySaucers = {}
local furySAmount = 0
local furySSpawned = 0
-- Fury timer
local furyCurrentTime = 1200
local furyAddedTime = 240

--Table to keep teams (for loops)
local cpu_teams = {cpu_frontline,cpu_main,cpu_bzooka,cpu_furies}

--Give control to AI teams
SetAIControl(cpu_furies, true)
for iT = 1,4 do
  SetAIControl(cpu_teams[iT], true)
end

--Handles for important objects
local FuryFactory1 = GetHandle("hbcrys0_i76building")

function Start()
-- Print welcome message
 DisplayMessage ("From the Fleet: Destroy all enemy opposition in the fortress and gain control of the center. Be prepared for any surprises the enemy might throw at us.")

  --Set max Scrap/Pilots for AI teams, and add Scrap.
  for iT = 1,3 do
    SetMaxScrap(cpu_teams[iT], 900)
    SetScrap(cpu_teams[iT], 890)
    SetMaxPilot (cpu_teams[iT], 30)
  end

  --Set AIPs for AI teams
  SetAIP("multstIoam1.aip", cpu_frontline)
  SetAIP("multstIoam2.aip", cpu_main)
  SetAIP("multstIosov.aip", cpu_bzooka)
  SetAIP("multstIofur.aip", cpu_furies)

  --Ally player teams
  Ally(1,2)
  Ally(1,3)
  Ally(2,3)

  --Ally AI teams
  Ally(cpu_frontline,cpu_main)
  Ally(cpu_frontline,cpu_bzooka)
  Ally(cpu_main,cpu_bzooka)

  --Lock alliances to prevent betrayal
  LockAllies(true)
end

function Update ()

--Keep pilots topped off
  for iT = 1,3 do
    SetPilot (cpu_teams[iT], 30)
  end

  if GetTime()>= 1640 then
    if not FuryMessage then
      DisplayMessage ("From the Fleet: We are detecting strange radar signatures coming from the fortress's center. Investigate with extreme caution.")
      FuryMessage = true
    end
  end

--Fury Patrols
  if IsAlive(FuryFactory1) and GetTime()>=furyTimeNext then
    furyTimeNext = furyTimeNext + furyTimeAdd

    -- Increase tank (and if applicable, saucer) fury count
    if furyWave < 9 then furyWave = furyWave + 1 end

    -- Fury tanks
    for i = 1, furyTanksToBuild[furyWave] do
      if not IsAlive(furyTanks[i]) then
        furyTanks[i] = BuildObject("hvsat", cpu_furies, FuryFactory1)
      end
    end
    -- Fury saucers
    if furyWave >= 5 then
      for i = 1, furyTanksToBuild[furyWave - 4] do
        if not IsAlive(furySaucers[i]) then
          furySaucers[i] = BuildObject("hvsav", cpu_furies, FuryFactory1)
        end
      end
    end
  end
end